package cordova.plugin.netcontroll.integration.multiscreen;

import cordova.plugin.netcontroll.integration.multiscreen.PresentationSession;
import cordova.plugin.netcontroll.integration.multiscreen.SecondScreenPresentation;

import android.os.AsyncTask;

import org.apache.cordova.CordovaPlugin;
import org.apache.cordova.CallbackContext;
import org.apache.cordova.CordovaInterface;
import org.apache.cordova.CordovaWebView;

import org.json.JSONArray;
import org.json.JSONException;

import android.app.Activity;
import android.content.Context;


//Second Monitor
import java.util.Collection;

import org.apache.cordova.PluginResult;
import org.apache.cordova.LOG;

import org.json.JSONObject;

import java.util.HashMap;
import java.util.Map;

import android.hardware.display.DisplayManager;
import android.view.Display;

import android.app.AlertDialog;
import android.content.DialogInterface;

//  implements DisplayManager.DisplayListener
public class NetControllCordovaPluginsIntegrationMultiScreen extends CordovaPlugin {
    // //Elgin
    // public ElginM10Terminal elginM10Terminal;
    // public ElginSmartPay elginSmartPay;

    // //Cielo
    // public CieloLioLocal cieloLioLocal;

    // //Rede
    // public RedeGPos700 redeGPos700;

    // //SafraPay
    // // public SafraPayIngenico safraPayIngenico;

    //TecToy
    public cordova.plugin.netcontroll.integration.multiscreen.TecToySumniD2Mini tecToySumniD2Mini;

    //Second Monitor
    private Map<String, PresentationSession> sessions;
    private Map<Integer, SecondScreenPresentation> presentations;
    private CallbackContext availableChangeCallbackContext;


    //Cordova/Java Params
    private Activity mActivity;
    private Context mContext;
    private CordovaInterface mCordova;
    private CordovaWebView webView;

    @Override
    public void initialize(CordovaInterface cordova, CordovaWebView webView) {
        this.webView = webView;
        mActivity = cordova.getActivity();
        mContext = cordova.getActivity().getApplicationContext();
        mCordova = cordova;
        super.initialize(cordova, webView);
    }

    private void initializeTecToySumniD2Mini() {
        if (this.tecToySumniD2Mini == null) {
            this.tecToySumniD2Mini = new cordova.plugin.netcontroll.integration.multiscreen.TecToySumniD2Mini();
            this.tecToySumniD2Mini.initialize(this.cordova, this.webView);
        }
    }

    @Override
    public boolean execute(String action, JSONArray args, CallbackContext callbackContext) throws JSONException {
        try {
            String result = "Sem resultado";
            String[] actionProviderList = action.split("\\.");
            String provider = actionProviderList[0];
            switch (provider.toLowerCase()) {
                case "tectoy":
                    String tecToyProduct = actionProviderList[1];
                    switch (tecToyProduct.toLowerCase()) {
                        case "tectoysumnid2mini":
                            this.initializeTecToySumniD2Mini();
                            String tecToyAction = actionProviderList[2];
                            boolean resultTecToyExecute = this.tecToySumniD2Mini.execute(tecToyAction, args, callbackContext);
                            return resultTecToyExecute;
                        default:
                            break;
                    }
                default:
                    break;
            }
            callbackContext.success(result);
            return true;
        } catch (Exception e) {
            callbackContext.error("NetControllCordovaPluginsIntegrationMultiScreen excute error: " + e.toString());
        }
        return false;
    }
}
