package cordova.plugin.netcontroll.integration.multiscreen;

import br.com.daruma.framework.mobile.DarumaMobile;
import br.com.daruma.framework.mobile.exception.DarumaException;
import cordova.plugin.netcontroll.integration.multiscreen.NetControllPrinter;

import cordova.plugin.netcontroll.integration.multiscreen.NetControllHelpers;

import org.apache.cordova.CordovaPlugin;
import org.apache.cordova.PluginResult;
import org.apache.cordova.CallbackContext;
import org.apache.cordova.CordovaInterface;
import org.apache.cordova.CordovaWebView;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.app.Activity;
import android.app.AlertDialog;
import android.graphics.Bitmap;
import android.content.Context;
import android.graphics.Rect;
import android.hardware.display.DisplayManager;
import android.os.Handler;
import android.os.Looper;
import android.os.Message;
import android.util.Log;
import android.view.Display;
import android.view.SurfaceView;
import android.view.View;
import android.webkit.WebView;
import android.widget.Toast;
import android.net.Uri;
import android.content.Intent;
import android.provider.MediaStore;

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Matrix;

import android.util.Base64;

import static android.app.Activity.RESULT_CANCELED;
import static android.app.Activity.RESULT_OK;

import java.util.HashMap;
import java.util.Map;


import android.graphics.Paint;
import android.graphics.Typeface;


import com.google.gson.annotations.SerializedName;
import com.google.zxing.WriterException;
import com.google.zxing.MultiFormatWriter;
import com.google.zxing.common.BitMatrix;
import com.google.zxing.BarcodeFormat;

// import com.journeyapps.barcodescanner.BarcodeEncoder;

import android.os.Build;


//Json Serialize
import com.google.gson.Gson;
import com.google.gson.GsonBuilder;

import java.util.List;

import com.google.zxing.EncodeHintType;

import android.os.AsyncTask;

import androidx.annotation.NonNull;
import androidx.annotation.RequiresApi;

import java.lang.reflect.Type;
import java.util.ArrayList;

import com.google.zxing.qrcode.decoder.ErrorCorrectionLevel;

import java.util.EnumMap;

import com.izettle.html2bitmap.Html2Bitmap;
import com.izettle.html2bitmap.content.WebViewContent;

import java.io.ByteArrayOutputStream;


//Printer
import android.os.Environment;

import java.io.IOException;

import android.graphics.Bitmap;

import br.com.daruma.framework.mobile.DarumaMobile;

public class TecToySumniD2Mini {
    //public class RedeGPos700 extends CordovaPlugin {
    //Cordova/Java Params
    private Activity mActivity;
    private Context mContext;
    private CordovaInterface mCordova;
    private CordovaWebView webView;

    // Impressao
    private DarumaMobile dmf;

    // Display
    private SurfaceView mPlayerView;
    private Display[] displays = null;
    boolean isMinScreen;
    private WebView myWebView;

    // //Rede
    // // CordovaPlugin useRedeResultCordovaPlugin;

    // //Intents CODES
    // private static int PAYMENT_REQUEST_CODE = 890001;
    // private static int REVERSAL_REQUEST_CODE = 890002;
    // private static int REPRINT_REQUEST_CODE = 890003;

    // public static final String G700 = "GPOS700";
    // private static final String version = "v1.0.0";

    // private RedePayments redePayments;
    // private GertecPrinter gertecPrinter;
    // private ConfigPrint configPrint = new ConfigPrint();
    // public static String Model = Build.MODEL;

    //CallbacksOnActivityResult
    private CallbackContext selecionarImagemCallbackContext;
    //cutPaper boolean for resultActivity
    // private boolean cutPaper = false;

    //    @Override
    public void initialize(CordovaInterface cordova, CordovaWebView webView) {
        //        super.initialize(cordova, webView);

        //        this.webView = webView;
        mActivity = cordova.getActivity();
        mContext = cordova.getActivity().getApplicationContext();
        mCordova = cordova;
        // DisplayManager mDisplayManager = (DisplayManager) mContext.getSystemService(Context.DISPLAY_SERVICE);
        // displays = mDisplayManager.getDisplays();
        // if (displays.length > 1) {
        //     Rect outSize0 = new Rect();
        //     displays[0].getRectSize(outSize0);

        //     Rect outSize1 = new Rect();
        //     displays[1].getRectSize(outSize1);

        //     if (outSize0.right - outSize1.right > 100) {
        //         isMinScreen = true;
        //     }
        // }
        // this.CriarSegundoMonitor();
        // String teste = "";
    }

    public String Teste() {
        return "Result - RedeGPos700: ok";
    }

    public boolean execute(String action, JSONArray args, CallbackContext callbackContext) throws JSONException {
        if (action.equals("Testar")) {
            try {

                callbackContext.success("Testardo");
            } catch (Exception e) {
                callbackContext.error("Testar error: " + e.toString());
            }
            return true;
        } else if (action.equals("InitializeSdk")) {
            JSONObject params = args.getJSONObject(0);
            try {
                NetControllPrinter.RequestPermissions(this.mActivity, this.mContext);
                dmf = DarumaMobile.inicializar(this.mActivity, "@FRAMEWORK(TRATAEXCECAO=TRUE;SATNATIVO=FALSE);@BLUETOOTH(ADDRESS=00:11:22:33:44:55;ATTEMPTS=100;TIMEOUT=10000)");
                return true;
            } catch (Exception error1) {
                callbackContext.error("Result - PagSeguro - Pax - InitializeSdk: " + "Error Detail: " + error1);
            }
        } else if (action.equals("ImpressaoTextoNetPrintImg")) {
            JSONObject params = args.getJSONObject(0);
            try {
                // if (plugpag == null) {
                //     callbackContext.error("ImpressaoTextoNetPrintImg error: Sdk não inicializado");
                //     return false;
                // }

                String dados = params.getString("dados");
                String html = NetControllPrinter.ConverterTextoImpressoToHtml(dados);
                NetControllPrinter.ConverterHtmlToBitmap(html, mContext, bitmapResult -> {
                    Bitmap dadosImg = bitmapResult;
                    String directoryFileName = Environment.getExternalStorageDirectory().getAbsolutePath() + "/Download/NetControllPrint.bmp";
//                    try {
//                        String fileName = NetControllPrinter.SaveImage(dadosImg, directoryFileName);
//                        if (!fileName.isEmpty()) {
                        this.ImprimirArquivo(dadosImg, directoryFileName, callbackContext);
//                        }
//                    } catch (IOException e) {
//                        e.printStackTrace();
//                    }
                });
            } catch (Exception e) {
                callbackContext.error("ImpressaoTextoNetPrintImg error: " + e.toString());
            }
            return true;
        }
        return false;
    }

    @RequiresApi(api = Build.VERSION_CODES.N)
    private boolean ImprimirArquivo(Bitmap bitmap, String caminhoArquivo, CallbackContext callbackContext) {
        try {
            if (caminhoArquivo != "") {
                dmf.iniciarComunicacao();

                ArrayList<String> caminhosArquivos = this.SalvarFragmentosImpresso(bitmap, caminhoArquivo);
//                caminhosArquivos.forEach((caminhoArquivoItem) -> {
//                    dmf.eImprimirBMPTecToy(caminhoArquivoItem);
//                });
                // dmf.enviarComando(""+((char) 0x1B)+((char) 0x61)+((char) 0x01)+((char) 0x1B)+((char) 0x45)+((char) 0x01)+"PRODUTO TESTE\n"+((char) 0x1B)+((char) 0x45)+((char) 0x30)+"prod. teste cod. 112233443321\n"+((char) 0x1D)+((char) 0x6B)+((char) 0x02)+"123456789012"+((char) 0x00)+"\n\n\n");
                dmf.enviarComando("\n\n\n\n\n");
                dmf.fecharComunicacao();
            }
        } catch (Exception errorPost) {
            callbackContext.error("Result - ImprimirArquivo: " + "Error Detail: " + errorPost);
            return false;
        }
        return true;
    }

//    @RequiresApi(api = Build.VERSION_CODES.N)
//    private boolean ImprimirArquivo2(String caminhoArquivo, CallbackContext callbackContext) {
//        try {
//            if (caminhoArquivo != "") {
//                dmf.iniciarComunicacao();
//                ArrayList<String> caminhosArquivos = this.SalvarFragmentosImpresso(caminhoArquivo);
//                caminhosArquivos.forEach((caminhoArquivoItem) -> {
//                    dmf.eImprimirBMPTecToy(caminhoArquivoItem);
//                });
//                dmf.fecharComunicacao();
//            }
//        } catch (Exception errorPost) {
//            callbackContext.error("Result - ImprimirArquivo: " + "Error Detail: " + errorPost);
//            return false;
//        }
//        return true;
//    }

    private ArrayList<String> SalvarFragmentosImpresso(Bitmap bitmap, String caminhoArquivo) throws IOException {
        ArrayList<String> result = new ArrayList<>();
        try {
            Bitmap bmp = bitmap;
            int imagesCount = bmp.getHeight() / 200;
            for (Integer x = 1; x <= imagesCount; x++) {
                Bitmap fragmentBmp = Bitmap.createBitmap(bmp, 0, (x - 1) * 200, bmp.getWidth(), 200);
                Bitmap fragmentBmpSalvar = fragmentBmp;
                String caminhoArquivoAtual = caminhoArquivo.replace("NetControllPrint.bmp", "NetControllPrint" + String.valueOf(x) + ".bmp");
                String currentImgPath = NetControllPrinter.SaveImage(fragmentBmp, caminhoArquivoAtual);
                dmf.eImprimirBMPTecToy(currentImgPath);
            }
            return result;
        } catch (Exception ex) {
            String exStr = ex.toString();
            throw ex;
        }
    }

    private ArrayList<String> SalvarFragmentosImpresso2(String caminhoArquivo) throws IOException {
        ArrayList<String> result = new ArrayList<>();
        try {
            Bitmap bmp = BitmapFactory.decodeFile(caminhoArquivo);
            int imagesCount = bmp.getHeight() / 200;
            for (Integer x = 1; x <= imagesCount; x++) {
                Bitmap fragmentBmp = Bitmap.createBitmap(bmp, 0, (x - 1) * 200, bmp.getWidth(), 200);
                Bitmap fragmentBmpSalvar = fragmentBmp;
                String caminhoArquivoAtual = caminhoArquivo.replace("NetControllPrint.bmp", "NetControllPrint" + String.valueOf(x) + ".bmp");
                String currentImgPath = NetControllPrinter.SaveImage(fragmentBmp, caminhoArquivoAtual);
                dmf.eImprimirBMPTecToy(currentImgPath);
            }
            return result;
        } catch (Exception ex) {
            String exStr = ex.toString();
            throw ex;
        }
    }
}
